// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package contract

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
	_ = abi.ConvertType
)

// ValidatorMetaData contains all meta data concerning the Validator contract.
var ValidatorMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"constructor\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"}],\"name\":\"OwnableInvalidOwner\",\"type\":\"error\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"OwnableUnauthorizedAccount\",\"type\":\"error\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"dailyReward\",\"type\":\"uint256\"}],\"name\":\"DailyRewardChanged\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"date\",\"type\":\"uint256\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleRoot\",\"type\":\"bytes32\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleSumRoot\",\"type\":\"bytes32\"},{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"totalWorkload\",\"type\":\"uint256\"}],\"name\":\"MerkleRootChanged\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleRoot\",\"type\":\"bytes32\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleSumRoot\",\"type\":\"bytes32\"},{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"count\",\"type\":\"uint256\"},{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"dailySubmitCount\",\"type\":\"uint256\"}],\"name\":\"MerkleRootSubmitted\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"merkleRootThreshold\",\"type\":\"uint256\"}],\"name\":\"MerkleRootThresholdChanged\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"bool\",\"name\":\"ok\",\"type\":\"bool\"},{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"count\",\"type\":\"uint256\"}],\"name\":\"ValidatorChanged\",\"type\":\"event\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"dailyMerkleRootMap\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"dailyMerkleRootSubmitCount\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"},{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"name\":\"dailyMerkleRootSubmitCountMap\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"},{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"dailyMerkleRootSubmittedMap\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"dailyMerkleRootVerifiedMap\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"dailyMerkleSumRootMap\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"dailyReward\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"dailyRewardMap\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"name\":\"dailyWorkloadMap\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getDailyReward\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getMerkleRoot\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_date\",\"type\":\"uint256\"}],\"name\":\"getRewardByDate\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getValidators\",\"outputs\":[{\"internalType\":\"address[]\",\"name\":\"\",\"type\":\"address[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_date\",\"type\":\"uint256\"}],\"name\":\"getWorkloadByDate\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"dailyWorkload\",\"type\":\"uint256\"}],\"name\":\"getWorkloadReward\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"}],\"name\":\"isValidator\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"lastMerkleRootUpdate\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"merkleRoot\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"merkleRootThreshold\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"merkleSumRoot\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_dailyReward\",\"type\":\"uint256\"}],\"name\":\"setDailyReward\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_merkleRootThreshold\",\"type\":\"uint256\"}],\"name\":\"setRootThreshold\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"},{\"internalType\":\"bool\",\"name\":\"ok\",\"type\":\"bool\"}],\"name\":\"setValidator\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_date\",\"type\":\"uint256\"},{\"internalType\":\"bytes32\",\"name\":\"_merkleRoot\",\"type\":\"bytes32\"},{\"internalType\":\"bytes32\",\"name\":\"_merkleSumRoot\",\"type\":\"bytes32\"},{\"internalType\":\"uint256\",\"name\":\"_totalWorkload\",\"type\":\"uint256\"}],\"name\":\"submitMerkleRoot\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"}]",
}

// ValidatorABI is the input ABI used to generate the binding from.
// Deprecated: Use ValidatorMetaData.ABI instead.
var ValidatorABI = ValidatorMetaData.ABI

// Validator is an auto generated Go binding around an Ethereum contract.
type Validator struct {
	ValidatorCaller     // Read-only binding to the contract
	ValidatorTransactor // Write-only binding to the contract
	ValidatorFilterer   // Log filterer for contract events
}

// ValidatorCaller is an auto generated read-only Go binding around an Ethereum contract.
type ValidatorCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ValidatorTransactor is an auto generated write-only Go binding around an Ethereum contract.
type ValidatorTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ValidatorFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type ValidatorFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// ValidatorSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type ValidatorSession struct {
	Contract     *Validator        // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// ValidatorCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type ValidatorCallerSession struct {
	Contract *ValidatorCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts    // Call options to use throughout this session
}

// ValidatorTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type ValidatorTransactorSession struct {
	Contract     *ValidatorTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts    // Transaction auth options to use throughout this session
}

// ValidatorRaw is an auto generated low-level Go binding around an Ethereum contract.
type ValidatorRaw struct {
	Contract *Validator // Generic contract binding to access the raw methods on
}

// ValidatorCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type ValidatorCallerRaw struct {
	Contract *ValidatorCaller // Generic read-only contract binding to access the raw methods on
}

// ValidatorTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type ValidatorTransactorRaw struct {
	Contract *ValidatorTransactor // Generic write-only contract binding to access the raw methods on
}

// NewValidator creates a new instance of Validator, bound to a specific deployed contract.
func NewValidator(address common.Address, backend bind.ContractBackend) (*Validator, error) {
	contract, err := bindValidator(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &Validator{ValidatorCaller: ValidatorCaller{contract: contract}, ValidatorTransactor: ValidatorTransactor{contract: contract}, ValidatorFilterer: ValidatorFilterer{contract: contract}}, nil
}

// NewValidatorCaller creates a new read-only instance of Validator, bound to a specific deployed contract.
func NewValidatorCaller(address common.Address, caller bind.ContractCaller) (*ValidatorCaller, error) {
	contract, err := bindValidator(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &ValidatorCaller{contract: contract}, nil
}

// NewValidatorTransactor creates a new write-only instance of Validator, bound to a specific deployed contract.
func NewValidatorTransactor(address common.Address, transactor bind.ContractTransactor) (*ValidatorTransactor, error) {
	contract, err := bindValidator(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &ValidatorTransactor{contract: contract}, nil
}

// NewValidatorFilterer creates a new log filterer instance of Validator, bound to a specific deployed contract.
func NewValidatorFilterer(address common.Address, filterer bind.ContractFilterer) (*ValidatorFilterer, error) {
	contract, err := bindValidator(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &ValidatorFilterer{contract: contract}, nil
}

// bindValidator binds a generic wrapper to an already deployed contract.
func bindValidator(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := ValidatorMetaData.GetAbi()
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, *parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Validator *ValidatorRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Validator.Contract.ValidatorCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Validator *ValidatorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Validator.Contract.ValidatorTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Validator *ValidatorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Validator.Contract.ValidatorTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Validator *ValidatorCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Validator.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Validator *ValidatorTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Validator.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Validator *ValidatorTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Validator.Contract.contract.Transact(opts, method, params...)
}

// DailyMerkleRootMap is a free data retrieval call binding the contract method 0xe43d2a0b.
//
// Solidity: function dailyMerkleRootMap(uint256 ) view returns(bytes32)
func (_Validator *ValidatorCaller) DailyMerkleRootMap(opts *bind.CallOpts, arg0 *big.Int) ([32]byte, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyMerkleRootMap", arg0)

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// DailyMerkleRootMap is a free data retrieval call binding the contract method 0xe43d2a0b.
//
// Solidity: function dailyMerkleRootMap(uint256 ) view returns(bytes32)
func (_Validator *ValidatorSession) DailyMerkleRootMap(arg0 *big.Int) ([32]byte, error) {
	return _Validator.Contract.DailyMerkleRootMap(&_Validator.CallOpts, arg0)
}

// DailyMerkleRootMap is a free data retrieval call binding the contract method 0xe43d2a0b.
//
// Solidity: function dailyMerkleRootMap(uint256 ) view returns(bytes32)
func (_Validator *ValidatorCallerSession) DailyMerkleRootMap(arg0 *big.Int) ([32]byte, error) {
	return _Validator.Contract.DailyMerkleRootMap(&_Validator.CallOpts, arg0)
}

// DailyMerkleRootSubmitCount is a free data retrieval call binding the contract method 0xeb6dd75e.
//
// Solidity: function dailyMerkleRootSubmitCount() view returns(uint256)
func (_Validator *ValidatorCaller) DailyMerkleRootSubmitCount(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyMerkleRootSubmitCount")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyMerkleRootSubmitCount is a free data retrieval call binding the contract method 0xeb6dd75e.
//
// Solidity: function dailyMerkleRootSubmitCount() view returns(uint256)
func (_Validator *ValidatorSession) DailyMerkleRootSubmitCount() (*big.Int, error) {
	return _Validator.Contract.DailyMerkleRootSubmitCount(&_Validator.CallOpts)
}

// DailyMerkleRootSubmitCount is a free data retrieval call binding the contract method 0xeb6dd75e.
//
// Solidity: function dailyMerkleRootSubmitCount() view returns(uint256)
func (_Validator *ValidatorCallerSession) DailyMerkleRootSubmitCount() (*big.Int, error) {
	return _Validator.Contract.DailyMerkleRootSubmitCount(&_Validator.CallOpts)
}

// DailyMerkleRootSubmitCountMap is a free data retrieval call binding the contract method 0x1c5d5b50.
//
// Solidity: function dailyMerkleRootSubmitCountMap(uint256 , bytes32 ) view returns(uint256)
func (_Validator *ValidatorCaller) DailyMerkleRootSubmitCountMap(opts *bind.CallOpts, arg0 *big.Int, arg1 [32]byte) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyMerkleRootSubmitCountMap", arg0, arg1)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyMerkleRootSubmitCountMap is a free data retrieval call binding the contract method 0x1c5d5b50.
//
// Solidity: function dailyMerkleRootSubmitCountMap(uint256 , bytes32 ) view returns(uint256)
func (_Validator *ValidatorSession) DailyMerkleRootSubmitCountMap(arg0 *big.Int, arg1 [32]byte) (*big.Int, error) {
	return _Validator.Contract.DailyMerkleRootSubmitCountMap(&_Validator.CallOpts, arg0, arg1)
}

// DailyMerkleRootSubmitCountMap is a free data retrieval call binding the contract method 0x1c5d5b50.
//
// Solidity: function dailyMerkleRootSubmitCountMap(uint256 , bytes32 ) view returns(uint256)
func (_Validator *ValidatorCallerSession) DailyMerkleRootSubmitCountMap(arg0 *big.Int, arg1 [32]byte) (*big.Int, error) {
	return _Validator.Contract.DailyMerkleRootSubmitCountMap(&_Validator.CallOpts, arg0, arg1)
}

// DailyMerkleRootSubmittedMap is a free data retrieval call binding the contract method 0xb0412a4a.
//
// Solidity: function dailyMerkleRootSubmittedMap(uint256 , address ) view returns(bool)
func (_Validator *ValidatorCaller) DailyMerkleRootSubmittedMap(opts *bind.CallOpts, arg0 *big.Int, arg1 common.Address) (bool, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyMerkleRootSubmittedMap", arg0, arg1)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// DailyMerkleRootSubmittedMap is a free data retrieval call binding the contract method 0xb0412a4a.
//
// Solidity: function dailyMerkleRootSubmittedMap(uint256 , address ) view returns(bool)
func (_Validator *ValidatorSession) DailyMerkleRootSubmittedMap(arg0 *big.Int, arg1 common.Address) (bool, error) {
	return _Validator.Contract.DailyMerkleRootSubmittedMap(&_Validator.CallOpts, arg0, arg1)
}

// DailyMerkleRootSubmittedMap is a free data retrieval call binding the contract method 0xb0412a4a.
//
// Solidity: function dailyMerkleRootSubmittedMap(uint256 , address ) view returns(bool)
func (_Validator *ValidatorCallerSession) DailyMerkleRootSubmittedMap(arg0 *big.Int, arg1 common.Address) (bool, error) {
	return _Validator.Contract.DailyMerkleRootSubmittedMap(&_Validator.CallOpts, arg0, arg1)
}

// DailyMerkleRootVerifiedMap is a free data retrieval call binding the contract method 0x3f8703eb.
//
// Solidity: function dailyMerkleRootVerifiedMap(uint256 ) view returns(bool)
func (_Validator *ValidatorCaller) DailyMerkleRootVerifiedMap(opts *bind.CallOpts, arg0 *big.Int) (bool, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyMerkleRootVerifiedMap", arg0)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// DailyMerkleRootVerifiedMap is a free data retrieval call binding the contract method 0x3f8703eb.
//
// Solidity: function dailyMerkleRootVerifiedMap(uint256 ) view returns(bool)
func (_Validator *ValidatorSession) DailyMerkleRootVerifiedMap(arg0 *big.Int) (bool, error) {
	return _Validator.Contract.DailyMerkleRootVerifiedMap(&_Validator.CallOpts, arg0)
}

// DailyMerkleRootVerifiedMap is a free data retrieval call binding the contract method 0x3f8703eb.
//
// Solidity: function dailyMerkleRootVerifiedMap(uint256 ) view returns(bool)
func (_Validator *ValidatorCallerSession) DailyMerkleRootVerifiedMap(arg0 *big.Int) (bool, error) {
	return _Validator.Contract.DailyMerkleRootVerifiedMap(&_Validator.CallOpts, arg0)
}

// DailyMerkleSumRootMap is a free data retrieval call binding the contract method 0x0837c38d.
//
// Solidity: function dailyMerkleSumRootMap(uint256 ) view returns(bytes32)
func (_Validator *ValidatorCaller) DailyMerkleSumRootMap(opts *bind.CallOpts, arg0 *big.Int) ([32]byte, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyMerkleSumRootMap", arg0)

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// DailyMerkleSumRootMap is a free data retrieval call binding the contract method 0x0837c38d.
//
// Solidity: function dailyMerkleSumRootMap(uint256 ) view returns(bytes32)
func (_Validator *ValidatorSession) DailyMerkleSumRootMap(arg0 *big.Int) ([32]byte, error) {
	return _Validator.Contract.DailyMerkleSumRootMap(&_Validator.CallOpts, arg0)
}

// DailyMerkleSumRootMap is a free data retrieval call binding the contract method 0x0837c38d.
//
// Solidity: function dailyMerkleSumRootMap(uint256 ) view returns(bytes32)
func (_Validator *ValidatorCallerSession) DailyMerkleSumRootMap(arg0 *big.Int) ([32]byte, error) {
	return _Validator.Contract.DailyMerkleSumRootMap(&_Validator.CallOpts, arg0)
}

// DailyReward is a free data retrieval call binding the contract method 0xc964ad45.
//
// Solidity: function dailyReward() view returns(uint256)
func (_Validator *ValidatorCaller) DailyReward(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyReward")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyReward is a free data retrieval call binding the contract method 0xc964ad45.
//
// Solidity: function dailyReward() view returns(uint256)
func (_Validator *ValidatorSession) DailyReward() (*big.Int, error) {
	return _Validator.Contract.DailyReward(&_Validator.CallOpts)
}

// DailyReward is a free data retrieval call binding the contract method 0xc964ad45.
//
// Solidity: function dailyReward() view returns(uint256)
func (_Validator *ValidatorCallerSession) DailyReward() (*big.Int, error) {
	return _Validator.Contract.DailyReward(&_Validator.CallOpts)
}

// DailyRewardMap is a free data retrieval call binding the contract method 0xa0576656.
//
// Solidity: function dailyRewardMap(uint256 ) view returns(uint256)
func (_Validator *ValidatorCaller) DailyRewardMap(opts *bind.CallOpts, arg0 *big.Int) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyRewardMap", arg0)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyRewardMap is a free data retrieval call binding the contract method 0xa0576656.
//
// Solidity: function dailyRewardMap(uint256 ) view returns(uint256)
func (_Validator *ValidatorSession) DailyRewardMap(arg0 *big.Int) (*big.Int, error) {
	return _Validator.Contract.DailyRewardMap(&_Validator.CallOpts, arg0)
}

// DailyRewardMap is a free data retrieval call binding the contract method 0xa0576656.
//
// Solidity: function dailyRewardMap(uint256 ) view returns(uint256)
func (_Validator *ValidatorCallerSession) DailyRewardMap(arg0 *big.Int) (*big.Int, error) {
	return _Validator.Contract.DailyRewardMap(&_Validator.CallOpts, arg0)
}

// DailyWorkloadMap is a free data retrieval call binding the contract method 0xb2e93afb.
//
// Solidity: function dailyWorkloadMap(uint256 ) view returns(uint256)
func (_Validator *ValidatorCaller) DailyWorkloadMap(opts *bind.CallOpts, arg0 *big.Int) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "dailyWorkloadMap", arg0)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyWorkloadMap is a free data retrieval call binding the contract method 0xb2e93afb.
//
// Solidity: function dailyWorkloadMap(uint256 ) view returns(uint256)
func (_Validator *ValidatorSession) DailyWorkloadMap(arg0 *big.Int) (*big.Int, error) {
	return _Validator.Contract.DailyWorkloadMap(&_Validator.CallOpts, arg0)
}

// DailyWorkloadMap is a free data retrieval call binding the contract method 0xb2e93afb.
//
// Solidity: function dailyWorkloadMap(uint256 ) view returns(uint256)
func (_Validator *ValidatorCallerSession) DailyWorkloadMap(arg0 *big.Int) (*big.Int, error) {
	return _Validator.Contract.DailyWorkloadMap(&_Validator.CallOpts, arg0)
}

// GetDailyReward is a free data retrieval call binding the contract method 0xadda10aa.
//
// Solidity: function getDailyReward() view returns(uint256)
func (_Validator *ValidatorCaller) GetDailyReward(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "getDailyReward")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetDailyReward is a free data retrieval call binding the contract method 0xadda10aa.
//
// Solidity: function getDailyReward() view returns(uint256)
func (_Validator *ValidatorSession) GetDailyReward() (*big.Int, error) {
	return _Validator.Contract.GetDailyReward(&_Validator.CallOpts)
}

// GetDailyReward is a free data retrieval call binding the contract method 0xadda10aa.
//
// Solidity: function getDailyReward() view returns(uint256)
func (_Validator *ValidatorCallerSession) GetDailyReward() (*big.Int, error) {
	return _Validator.Contract.GetDailyReward(&_Validator.CallOpts)
}

// GetMerkleRoot is a free data retrieval call binding the contract method 0x49590657.
//
// Solidity: function getMerkleRoot() view returns(bytes32)
func (_Validator *ValidatorCaller) GetMerkleRoot(opts *bind.CallOpts) ([32]byte, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "getMerkleRoot")

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// GetMerkleRoot is a free data retrieval call binding the contract method 0x49590657.
//
// Solidity: function getMerkleRoot() view returns(bytes32)
func (_Validator *ValidatorSession) GetMerkleRoot() ([32]byte, error) {
	return _Validator.Contract.GetMerkleRoot(&_Validator.CallOpts)
}

// GetMerkleRoot is a free data retrieval call binding the contract method 0x49590657.
//
// Solidity: function getMerkleRoot() view returns(bytes32)
func (_Validator *ValidatorCallerSession) GetMerkleRoot() ([32]byte, error) {
	return _Validator.Contract.GetMerkleRoot(&_Validator.CallOpts)
}

// GetRewardByDate is a free data retrieval call binding the contract method 0x06b3e9c6.
//
// Solidity: function getRewardByDate(uint256 _date) view returns(uint256)
func (_Validator *ValidatorCaller) GetRewardByDate(opts *bind.CallOpts, _date *big.Int) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "getRewardByDate", _date)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetRewardByDate is a free data retrieval call binding the contract method 0x06b3e9c6.
//
// Solidity: function getRewardByDate(uint256 _date) view returns(uint256)
func (_Validator *ValidatorSession) GetRewardByDate(_date *big.Int) (*big.Int, error) {
	return _Validator.Contract.GetRewardByDate(&_Validator.CallOpts, _date)
}

// GetRewardByDate is a free data retrieval call binding the contract method 0x06b3e9c6.
//
// Solidity: function getRewardByDate(uint256 _date) view returns(uint256)
func (_Validator *ValidatorCallerSession) GetRewardByDate(_date *big.Int) (*big.Int, error) {
	return _Validator.Contract.GetRewardByDate(&_Validator.CallOpts, _date)
}

// GetValidators is a free data retrieval call binding the contract method 0xb7ab4db5.
//
// Solidity: function getValidators() view returns(address[])
func (_Validator *ValidatorCaller) GetValidators(opts *bind.CallOpts) ([]common.Address, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "getValidators")

	if err != nil {
		return *new([]common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new([]common.Address)).(*[]common.Address)

	return out0, err

}

// GetValidators is a free data retrieval call binding the contract method 0xb7ab4db5.
//
// Solidity: function getValidators() view returns(address[])
func (_Validator *ValidatorSession) GetValidators() ([]common.Address, error) {
	return _Validator.Contract.GetValidators(&_Validator.CallOpts)
}

// GetValidators is a free data retrieval call binding the contract method 0xb7ab4db5.
//
// Solidity: function getValidators() view returns(address[])
func (_Validator *ValidatorCallerSession) GetValidators() ([]common.Address, error) {
	return _Validator.Contract.GetValidators(&_Validator.CallOpts)
}

// GetWorkloadByDate is a free data retrieval call binding the contract method 0xe916eb9e.
//
// Solidity: function getWorkloadByDate(uint256 _date) view returns(uint256)
func (_Validator *ValidatorCaller) GetWorkloadByDate(opts *bind.CallOpts, _date *big.Int) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "getWorkloadByDate", _date)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetWorkloadByDate is a free data retrieval call binding the contract method 0xe916eb9e.
//
// Solidity: function getWorkloadByDate(uint256 _date) view returns(uint256)
func (_Validator *ValidatorSession) GetWorkloadByDate(_date *big.Int) (*big.Int, error) {
	return _Validator.Contract.GetWorkloadByDate(&_Validator.CallOpts, _date)
}

// GetWorkloadByDate is a free data retrieval call binding the contract method 0xe916eb9e.
//
// Solidity: function getWorkloadByDate(uint256 _date) view returns(uint256)
func (_Validator *ValidatorCallerSession) GetWorkloadByDate(_date *big.Int) (*big.Int, error) {
	return _Validator.Contract.GetWorkloadByDate(&_Validator.CallOpts, _date)
}

// GetWorkloadReward is a free data retrieval call binding the contract method 0xb01507ce.
//
// Solidity: function getWorkloadReward(uint256 dailyWorkload) view returns(uint256)
func (_Validator *ValidatorCaller) GetWorkloadReward(opts *bind.CallOpts, dailyWorkload *big.Int) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "getWorkloadReward", dailyWorkload)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetWorkloadReward is a free data retrieval call binding the contract method 0xb01507ce.
//
// Solidity: function getWorkloadReward(uint256 dailyWorkload) view returns(uint256)
func (_Validator *ValidatorSession) GetWorkloadReward(dailyWorkload *big.Int) (*big.Int, error) {
	return _Validator.Contract.GetWorkloadReward(&_Validator.CallOpts, dailyWorkload)
}

// GetWorkloadReward is a free data retrieval call binding the contract method 0xb01507ce.
//
// Solidity: function getWorkloadReward(uint256 dailyWorkload) view returns(uint256)
func (_Validator *ValidatorCallerSession) GetWorkloadReward(dailyWorkload *big.Int) (*big.Int, error) {
	return _Validator.Contract.GetWorkloadReward(&_Validator.CallOpts, dailyWorkload)
}

// IsValidator is a free data retrieval call binding the contract method 0xfacd743b.
//
// Solidity: function isValidator(address addr) view returns(bool)
func (_Validator *ValidatorCaller) IsValidator(opts *bind.CallOpts, addr common.Address) (bool, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "isValidator", addr)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// IsValidator is a free data retrieval call binding the contract method 0xfacd743b.
//
// Solidity: function isValidator(address addr) view returns(bool)
func (_Validator *ValidatorSession) IsValidator(addr common.Address) (bool, error) {
	return _Validator.Contract.IsValidator(&_Validator.CallOpts, addr)
}

// IsValidator is a free data retrieval call binding the contract method 0xfacd743b.
//
// Solidity: function isValidator(address addr) view returns(bool)
func (_Validator *ValidatorCallerSession) IsValidator(addr common.Address) (bool, error) {
	return _Validator.Contract.IsValidator(&_Validator.CallOpts, addr)
}

// LastMerkleRootUpdate is a free data retrieval call binding the contract method 0xed86955e.
//
// Solidity: function lastMerkleRootUpdate() view returns(uint256)
func (_Validator *ValidatorCaller) LastMerkleRootUpdate(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "lastMerkleRootUpdate")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// LastMerkleRootUpdate is a free data retrieval call binding the contract method 0xed86955e.
//
// Solidity: function lastMerkleRootUpdate() view returns(uint256)
func (_Validator *ValidatorSession) LastMerkleRootUpdate() (*big.Int, error) {
	return _Validator.Contract.LastMerkleRootUpdate(&_Validator.CallOpts)
}

// LastMerkleRootUpdate is a free data retrieval call binding the contract method 0xed86955e.
//
// Solidity: function lastMerkleRootUpdate() view returns(uint256)
func (_Validator *ValidatorCallerSession) LastMerkleRootUpdate() (*big.Int, error) {
	return _Validator.Contract.LastMerkleRootUpdate(&_Validator.CallOpts)
}

// MerkleRoot is a free data retrieval call binding the contract method 0x2eb4a7ab.
//
// Solidity: function merkleRoot() view returns(bytes32)
func (_Validator *ValidatorCaller) MerkleRoot(opts *bind.CallOpts) ([32]byte, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "merkleRoot")

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// MerkleRoot is a free data retrieval call binding the contract method 0x2eb4a7ab.
//
// Solidity: function merkleRoot() view returns(bytes32)
func (_Validator *ValidatorSession) MerkleRoot() ([32]byte, error) {
	return _Validator.Contract.MerkleRoot(&_Validator.CallOpts)
}

// MerkleRoot is a free data retrieval call binding the contract method 0x2eb4a7ab.
//
// Solidity: function merkleRoot() view returns(bytes32)
func (_Validator *ValidatorCallerSession) MerkleRoot() ([32]byte, error) {
	return _Validator.Contract.MerkleRoot(&_Validator.CallOpts)
}

// MerkleRootThreshold is a free data retrieval call binding the contract method 0x63bd80dd.
//
// Solidity: function merkleRootThreshold() view returns(uint256)
func (_Validator *ValidatorCaller) MerkleRootThreshold(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "merkleRootThreshold")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// MerkleRootThreshold is a free data retrieval call binding the contract method 0x63bd80dd.
//
// Solidity: function merkleRootThreshold() view returns(uint256)
func (_Validator *ValidatorSession) MerkleRootThreshold() (*big.Int, error) {
	return _Validator.Contract.MerkleRootThreshold(&_Validator.CallOpts)
}

// MerkleRootThreshold is a free data retrieval call binding the contract method 0x63bd80dd.
//
// Solidity: function merkleRootThreshold() view returns(uint256)
func (_Validator *ValidatorCallerSession) MerkleRootThreshold() (*big.Int, error) {
	return _Validator.Contract.MerkleRootThreshold(&_Validator.CallOpts)
}

// MerkleSumRoot is a free data retrieval call binding the contract method 0x529d7e7c.
//
// Solidity: function merkleSumRoot() view returns(bytes32)
func (_Validator *ValidatorCaller) MerkleSumRoot(opts *bind.CallOpts) ([32]byte, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "merkleSumRoot")

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// MerkleSumRoot is a free data retrieval call binding the contract method 0x529d7e7c.
//
// Solidity: function merkleSumRoot() view returns(bytes32)
func (_Validator *ValidatorSession) MerkleSumRoot() ([32]byte, error) {
	return _Validator.Contract.MerkleSumRoot(&_Validator.CallOpts)
}

// MerkleSumRoot is a free data retrieval call binding the contract method 0x529d7e7c.
//
// Solidity: function merkleSumRoot() view returns(bytes32)
func (_Validator *ValidatorCallerSession) MerkleSumRoot() ([32]byte, error) {
	return _Validator.Contract.MerkleSumRoot(&_Validator.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Validator *ValidatorCaller) Owner(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Validator.contract.Call(opts, &out, "owner")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Validator *ValidatorSession) Owner() (common.Address, error) {
	return _Validator.Contract.Owner(&_Validator.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Validator *ValidatorCallerSession) Owner() (common.Address, error) {
	return _Validator.Contract.Owner(&_Validator.CallOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Validator *ValidatorTransactor) RenounceOwnership(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Validator.contract.Transact(opts, "renounceOwnership")
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Validator *ValidatorSession) RenounceOwnership() (*types.Transaction, error) {
	return _Validator.Contract.RenounceOwnership(&_Validator.TransactOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Validator *ValidatorTransactorSession) RenounceOwnership() (*types.Transaction, error) {
	return _Validator.Contract.RenounceOwnership(&_Validator.TransactOpts)
}

// SetDailyReward is a paid mutator transaction binding the contract method 0x0aa43533.
//
// Solidity: function setDailyReward(uint256 _dailyReward) returns()
func (_Validator *ValidatorTransactor) SetDailyReward(opts *bind.TransactOpts, _dailyReward *big.Int) (*types.Transaction, error) {
	return _Validator.contract.Transact(opts, "setDailyReward", _dailyReward)
}

// SetDailyReward is a paid mutator transaction binding the contract method 0x0aa43533.
//
// Solidity: function setDailyReward(uint256 _dailyReward) returns()
func (_Validator *ValidatorSession) SetDailyReward(_dailyReward *big.Int) (*types.Transaction, error) {
	return _Validator.Contract.SetDailyReward(&_Validator.TransactOpts, _dailyReward)
}

// SetDailyReward is a paid mutator transaction binding the contract method 0x0aa43533.
//
// Solidity: function setDailyReward(uint256 _dailyReward) returns()
func (_Validator *ValidatorTransactorSession) SetDailyReward(_dailyReward *big.Int) (*types.Transaction, error) {
	return _Validator.Contract.SetDailyReward(&_Validator.TransactOpts, _dailyReward)
}

// SetRootThreshold is a paid mutator transaction binding the contract method 0x718b08a8.
//
// Solidity: function setRootThreshold(uint256 _merkleRootThreshold) returns()
func (_Validator *ValidatorTransactor) SetRootThreshold(opts *bind.TransactOpts, _merkleRootThreshold *big.Int) (*types.Transaction, error) {
	return _Validator.contract.Transact(opts, "setRootThreshold", _merkleRootThreshold)
}

// SetRootThreshold is a paid mutator transaction binding the contract method 0x718b08a8.
//
// Solidity: function setRootThreshold(uint256 _merkleRootThreshold) returns()
func (_Validator *ValidatorSession) SetRootThreshold(_merkleRootThreshold *big.Int) (*types.Transaction, error) {
	return _Validator.Contract.SetRootThreshold(&_Validator.TransactOpts, _merkleRootThreshold)
}

// SetRootThreshold is a paid mutator transaction binding the contract method 0x718b08a8.
//
// Solidity: function setRootThreshold(uint256 _merkleRootThreshold) returns()
func (_Validator *ValidatorTransactorSession) SetRootThreshold(_merkleRootThreshold *big.Int) (*types.Transaction, error) {
	return _Validator.Contract.SetRootThreshold(&_Validator.TransactOpts, _merkleRootThreshold)
}

// SetValidator is a paid mutator transaction binding the contract method 0x4623c91d.
//
// Solidity: function setValidator(address addr, bool ok) returns()
func (_Validator *ValidatorTransactor) SetValidator(opts *bind.TransactOpts, addr common.Address, ok bool) (*types.Transaction, error) {
	return _Validator.contract.Transact(opts, "setValidator", addr, ok)
}

// SetValidator is a paid mutator transaction binding the contract method 0x4623c91d.
//
// Solidity: function setValidator(address addr, bool ok) returns()
func (_Validator *ValidatorSession) SetValidator(addr common.Address, ok bool) (*types.Transaction, error) {
	return _Validator.Contract.SetValidator(&_Validator.TransactOpts, addr, ok)
}

// SetValidator is a paid mutator transaction binding the contract method 0x4623c91d.
//
// Solidity: function setValidator(address addr, bool ok) returns()
func (_Validator *ValidatorTransactorSession) SetValidator(addr common.Address, ok bool) (*types.Transaction, error) {
	return _Validator.Contract.SetValidator(&_Validator.TransactOpts, addr, ok)
}

// SubmitMerkleRoot is a paid mutator transaction binding the contract method 0xed3a4aea.
//
// Solidity: function submitMerkleRoot(uint256 _date, bytes32 _merkleRoot, bytes32 _merkleSumRoot, uint256 _totalWorkload) returns()
func (_Validator *ValidatorTransactor) SubmitMerkleRoot(opts *bind.TransactOpts, _date *big.Int, _merkleRoot [32]byte, _merkleSumRoot [32]byte, _totalWorkload *big.Int) (*types.Transaction, error) {
	return _Validator.contract.Transact(opts, "submitMerkleRoot", _date, _merkleRoot, _merkleSumRoot, _totalWorkload)
}

// SubmitMerkleRoot is a paid mutator transaction binding the contract method 0xed3a4aea.
//
// Solidity: function submitMerkleRoot(uint256 _date, bytes32 _merkleRoot, bytes32 _merkleSumRoot, uint256 _totalWorkload) returns()
func (_Validator *ValidatorSession) SubmitMerkleRoot(_date *big.Int, _merkleRoot [32]byte, _merkleSumRoot [32]byte, _totalWorkload *big.Int) (*types.Transaction, error) {
	return _Validator.Contract.SubmitMerkleRoot(&_Validator.TransactOpts, _date, _merkleRoot, _merkleSumRoot, _totalWorkload)
}

// SubmitMerkleRoot is a paid mutator transaction binding the contract method 0xed3a4aea.
//
// Solidity: function submitMerkleRoot(uint256 _date, bytes32 _merkleRoot, bytes32 _merkleSumRoot, uint256 _totalWorkload) returns()
func (_Validator *ValidatorTransactorSession) SubmitMerkleRoot(_date *big.Int, _merkleRoot [32]byte, _merkleSumRoot [32]byte, _totalWorkload *big.Int) (*types.Transaction, error) {
	return _Validator.Contract.SubmitMerkleRoot(&_Validator.TransactOpts, _date, _merkleRoot, _merkleSumRoot, _totalWorkload)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Validator *ValidatorTransactor) TransferOwnership(opts *bind.TransactOpts, newOwner common.Address) (*types.Transaction, error) {
	return _Validator.contract.Transact(opts, "transferOwnership", newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Validator *ValidatorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Validator.Contract.TransferOwnership(&_Validator.TransactOpts, newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Validator *ValidatorTransactorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Validator.Contract.TransferOwnership(&_Validator.TransactOpts, newOwner)
}

// ValidatorDailyRewardChangedIterator is returned from FilterDailyRewardChanged and is used to iterate over the raw logs and unpacked data for DailyRewardChanged events raised by the Validator contract.
type ValidatorDailyRewardChangedIterator struct {
	Event *ValidatorDailyRewardChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ValidatorDailyRewardChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ValidatorDailyRewardChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ValidatorDailyRewardChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ValidatorDailyRewardChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ValidatorDailyRewardChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ValidatorDailyRewardChanged represents a DailyRewardChanged event raised by the Validator contract.
type ValidatorDailyRewardChanged struct {
	DailyReward *big.Int
	Raw         types.Log // Blockchain specific contextual infos
}

// FilterDailyRewardChanged is a free log retrieval operation binding the contract event 0xf1649f58e4104d40851477a70db43e4ed6979ae52986533c3bc43abb6642dcfa.
//
// Solidity: event DailyRewardChanged(uint256 dailyReward)
func (_Validator *ValidatorFilterer) FilterDailyRewardChanged(opts *bind.FilterOpts) (*ValidatorDailyRewardChangedIterator, error) {

	logs, sub, err := _Validator.contract.FilterLogs(opts, "DailyRewardChanged")
	if err != nil {
		return nil, err
	}
	return &ValidatorDailyRewardChangedIterator{contract: _Validator.contract, event: "DailyRewardChanged", logs: logs, sub: sub}, nil
}

// WatchDailyRewardChanged is a free log subscription operation binding the contract event 0xf1649f58e4104d40851477a70db43e4ed6979ae52986533c3bc43abb6642dcfa.
//
// Solidity: event DailyRewardChanged(uint256 dailyReward)
func (_Validator *ValidatorFilterer) WatchDailyRewardChanged(opts *bind.WatchOpts, sink chan<- *ValidatorDailyRewardChanged) (event.Subscription, error) {

	logs, sub, err := _Validator.contract.WatchLogs(opts, "DailyRewardChanged")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ValidatorDailyRewardChanged)
				if err := _Validator.contract.UnpackLog(event, "DailyRewardChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseDailyRewardChanged is a log parse operation binding the contract event 0xf1649f58e4104d40851477a70db43e4ed6979ae52986533c3bc43abb6642dcfa.
//
// Solidity: event DailyRewardChanged(uint256 dailyReward)
func (_Validator *ValidatorFilterer) ParseDailyRewardChanged(log types.Log) (*ValidatorDailyRewardChanged, error) {
	event := new(ValidatorDailyRewardChanged)
	if err := _Validator.contract.UnpackLog(event, "DailyRewardChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ValidatorMerkleRootChangedIterator is returned from FilterMerkleRootChanged and is used to iterate over the raw logs and unpacked data for MerkleRootChanged events raised by the Validator contract.
type ValidatorMerkleRootChangedIterator struct {
	Event *ValidatorMerkleRootChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ValidatorMerkleRootChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ValidatorMerkleRootChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ValidatorMerkleRootChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ValidatorMerkleRootChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ValidatorMerkleRootChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ValidatorMerkleRootChanged represents a MerkleRootChanged event raised by the Validator contract.
type ValidatorMerkleRootChanged struct {
	Date          *big.Int
	MerkleRoot    [32]byte
	MerkleSumRoot [32]byte
	TotalWorkload *big.Int
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterMerkleRootChanged is a free log retrieval operation binding the contract event 0x508346920f1af9cf4c72254f4a8c35d5ca2c0c8121f2f1a22952b7179d9e352b.
//
// Solidity: event MerkleRootChanged(uint256 date, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 totalWorkload)
func (_Validator *ValidatorFilterer) FilterMerkleRootChanged(opts *bind.FilterOpts) (*ValidatorMerkleRootChangedIterator, error) {

	logs, sub, err := _Validator.contract.FilterLogs(opts, "MerkleRootChanged")
	if err != nil {
		return nil, err
	}
	return &ValidatorMerkleRootChangedIterator{contract: _Validator.contract, event: "MerkleRootChanged", logs: logs, sub: sub}, nil
}

// WatchMerkleRootChanged is a free log subscription operation binding the contract event 0x508346920f1af9cf4c72254f4a8c35d5ca2c0c8121f2f1a22952b7179d9e352b.
//
// Solidity: event MerkleRootChanged(uint256 date, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 totalWorkload)
func (_Validator *ValidatorFilterer) WatchMerkleRootChanged(opts *bind.WatchOpts, sink chan<- *ValidatorMerkleRootChanged) (event.Subscription, error) {

	logs, sub, err := _Validator.contract.WatchLogs(opts, "MerkleRootChanged")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ValidatorMerkleRootChanged)
				if err := _Validator.contract.UnpackLog(event, "MerkleRootChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseMerkleRootChanged is a log parse operation binding the contract event 0x508346920f1af9cf4c72254f4a8c35d5ca2c0c8121f2f1a22952b7179d9e352b.
//
// Solidity: event MerkleRootChanged(uint256 date, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 totalWorkload)
func (_Validator *ValidatorFilterer) ParseMerkleRootChanged(log types.Log) (*ValidatorMerkleRootChanged, error) {
	event := new(ValidatorMerkleRootChanged)
	if err := _Validator.contract.UnpackLog(event, "MerkleRootChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ValidatorMerkleRootSubmittedIterator is returned from FilterMerkleRootSubmitted and is used to iterate over the raw logs and unpacked data for MerkleRootSubmitted events raised by the Validator contract.
type ValidatorMerkleRootSubmittedIterator struct {
	Event *ValidatorMerkleRootSubmitted // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ValidatorMerkleRootSubmittedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ValidatorMerkleRootSubmitted)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ValidatorMerkleRootSubmitted)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ValidatorMerkleRootSubmittedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ValidatorMerkleRootSubmittedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ValidatorMerkleRootSubmitted represents a MerkleRootSubmitted event raised by the Validator contract.
type ValidatorMerkleRootSubmitted struct {
	Addr             common.Address
	MerkleRoot       [32]byte
	MerkleSumRoot    [32]byte
	Count            *big.Int
	DailySubmitCount *big.Int
	Raw              types.Log // Blockchain specific contextual infos
}

// FilterMerkleRootSubmitted is a free log retrieval operation binding the contract event 0x7c0db56049d8c21ac04eb9f10f3a12460a3cd42c97482ed65838b868f685a34d.
//
// Solidity: event MerkleRootSubmitted(address indexed addr, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 indexed count, uint256 indexed dailySubmitCount)
func (_Validator *ValidatorFilterer) FilterMerkleRootSubmitted(opts *bind.FilterOpts, addr []common.Address, count []*big.Int, dailySubmitCount []*big.Int) (*ValidatorMerkleRootSubmittedIterator, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}

	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}
	var dailySubmitCountRule []interface{}
	for _, dailySubmitCountItem := range dailySubmitCount {
		dailySubmitCountRule = append(dailySubmitCountRule, dailySubmitCountItem)
	}

	logs, sub, err := _Validator.contract.FilterLogs(opts, "MerkleRootSubmitted", addrRule, countRule, dailySubmitCountRule)
	if err != nil {
		return nil, err
	}
	return &ValidatorMerkleRootSubmittedIterator{contract: _Validator.contract, event: "MerkleRootSubmitted", logs: logs, sub: sub}, nil
}

// WatchMerkleRootSubmitted is a free log subscription operation binding the contract event 0x7c0db56049d8c21ac04eb9f10f3a12460a3cd42c97482ed65838b868f685a34d.
//
// Solidity: event MerkleRootSubmitted(address indexed addr, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 indexed count, uint256 indexed dailySubmitCount)
func (_Validator *ValidatorFilterer) WatchMerkleRootSubmitted(opts *bind.WatchOpts, sink chan<- *ValidatorMerkleRootSubmitted, addr []common.Address, count []*big.Int, dailySubmitCount []*big.Int) (event.Subscription, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}

	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}
	var dailySubmitCountRule []interface{}
	for _, dailySubmitCountItem := range dailySubmitCount {
		dailySubmitCountRule = append(dailySubmitCountRule, dailySubmitCountItem)
	}

	logs, sub, err := _Validator.contract.WatchLogs(opts, "MerkleRootSubmitted", addrRule, countRule, dailySubmitCountRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ValidatorMerkleRootSubmitted)
				if err := _Validator.contract.UnpackLog(event, "MerkleRootSubmitted", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseMerkleRootSubmitted is a log parse operation binding the contract event 0x7c0db56049d8c21ac04eb9f10f3a12460a3cd42c97482ed65838b868f685a34d.
//
// Solidity: event MerkleRootSubmitted(address indexed addr, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 indexed count, uint256 indexed dailySubmitCount)
func (_Validator *ValidatorFilterer) ParseMerkleRootSubmitted(log types.Log) (*ValidatorMerkleRootSubmitted, error) {
	event := new(ValidatorMerkleRootSubmitted)
	if err := _Validator.contract.UnpackLog(event, "MerkleRootSubmitted", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ValidatorMerkleRootThresholdChangedIterator is returned from FilterMerkleRootThresholdChanged and is used to iterate over the raw logs and unpacked data for MerkleRootThresholdChanged events raised by the Validator contract.
type ValidatorMerkleRootThresholdChangedIterator struct {
	Event *ValidatorMerkleRootThresholdChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ValidatorMerkleRootThresholdChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ValidatorMerkleRootThresholdChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ValidatorMerkleRootThresholdChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ValidatorMerkleRootThresholdChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ValidatorMerkleRootThresholdChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ValidatorMerkleRootThresholdChanged represents a MerkleRootThresholdChanged event raised by the Validator contract.
type ValidatorMerkleRootThresholdChanged struct {
	MerkleRootThreshold *big.Int
	Raw                 types.Log // Blockchain specific contextual infos
}

// FilterMerkleRootThresholdChanged is a free log retrieval operation binding the contract event 0xd43620d8f66512fa8246fc8c49d14f776a9938857d9e877639cc92a2955d5a4c.
//
// Solidity: event MerkleRootThresholdChanged(uint256 merkleRootThreshold)
func (_Validator *ValidatorFilterer) FilterMerkleRootThresholdChanged(opts *bind.FilterOpts) (*ValidatorMerkleRootThresholdChangedIterator, error) {

	logs, sub, err := _Validator.contract.FilterLogs(opts, "MerkleRootThresholdChanged")
	if err != nil {
		return nil, err
	}
	return &ValidatorMerkleRootThresholdChangedIterator{contract: _Validator.contract, event: "MerkleRootThresholdChanged", logs: logs, sub: sub}, nil
}

// WatchMerkleRootThresholdChanged is a free log subscription operation binding the contract event 0xd43620d8f66512fa8246fc8c49d14f776a9938857d9e877639cc92a2955d5a4c.
//
// Solidity: event MerkleRootThresholdChanged(uint256 merkleRootThreshold)
func (_Validator *ValidatorFilterer) WatchMerkleRootThresholdChanged(opts *bind.WatchOpts, sink chan<- *ValidatorMerkleRootThresholdChanged) (event.Subscription, error) {

	logs, sub, err := _Validator.contract.WatchLogs(opts, "MerkleRootThresholdChanged")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ValidatorMerkleRootThresholdChanged)
				if err := _Validator.contract.UnpackLog(event, "MerkleRootThresholdChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseMerkleRootThresholdChanged is a log parse operation binding the contract event 0xd43620d8f66512fa8246fc8c49d14f776a9938857d9e877639cc92a2955d5a4c.
//
// Solidity: event MerkleRootThresholdChanged(uint256 merkleRootThreshold)
func (_Validator *ValidatorFilterer) ParseMerkleRootThresholdChanged(log types.Log) (*ValidatorMerkleRootThresholdChanged, error) {
	event := new(ValidatorMerkleRootThresholdChanged)
	if err := _Validator.contract.UnpackLog(event, "MerkleRootThresholdChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ValidatorOwnershipTransferredIterator is returned from FilterOwnershipTransferred and is used to iterate over the raw logs and unpacked data for OwnershipTransferred events raised by the Validator contract.
type ValidatorOwnershipTransferredIterator struct {
	Event *ValidatorOwnershipTransferred // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ValidatorOwnershipTransferredIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ValidatorOwnershipTransferred)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ValidatorOwnershipTransferred)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ValidatorOwnershipTransferredIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ValidatorOwnershipTransferredIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ValidatorOwnershipTransferred represents a OwnershipTransferred event raised by the Validator contract.
type ValidatorOwnershipTransferred struct {
	PreviousOwner common.Address
	NewOwner      common.Address
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterOwnershipTransferred is a free log retrieval operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Validator *ValidatorFilterer) FilterOwnershipTransferred(opts *bind.FilterOpts, previousOwner []common.Address, newOwner []common.Address) (*ValidatorOwnershipTransferredIterator, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Validator.contract.FilterLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return &ValidatorOwnershipTransferredIterator{contract: _Validator.contract, event: "OwnershipTransferred", logs: logs, sub: sub}, nil
}

// WatchOwnershipTransferred is a free log subscription operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Validator *ValidatorFilterer) WatchOwnershipTransferred(opts *bind.WatchOpts, sink chan<- *ValidatorOwnershipTransferred, previousOwner []common.Address, newOwner []common.Address) (event.Subscription, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Validator.contract.WatchLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ValidatorOwnershipTransferred)
				if err := _Validator.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseOwnershipTransferred is a log parse operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Validator *ValidatorFilterer) ParseOwnershipTransferred(log types.Log) (*ValidatorOwnershipTransferred, error) {
	event := new(ValidatorOwnershipTransferred)
	if err := _Validator.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// ValidatorValidatorChangedIterator is returned from FilterValidatorChanged and is used to iterate over the raw logs and unpacked data for ValidatorChanged events raised by the Validator contract.
type ValidatorValidatorChangedIterator struct {
	Event *ValidatorValidatorChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *ValidatorValidatorChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(ValidatorValidatorChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(ValidatorValidatorChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *ValidatorValidatorChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *ValidatorValidatorChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// ValidatorValidatorChanged represents a ValidatorChanged event raised by the Validator contract.
type ValidatorValidatorChanged struct {
	Addr  common.Address
	Ok    bool
	Count *big.Int
	Raw   types.Log // Blockchain specific contextual infos
}

// FilterValidatorChanged is a free log retrieval operation binding the contract event 0x68eee2a57e96a90e746ad2bfb99fd2baa69684672e6f1ea09adad5eb88f3914a.
//
// Solidity: event ValidatorChanged(address indexed addr, bool indexed ok, uint256 indexed count)
func (_Validator *ValidatorFilterer) FilterValidatorChanged(opts *bind.FilterOpts, addr []common.Address, ok []bool, count []*big.Int) (*ValidatorValidatorChangedIterator, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}
	var okRule []interface{}
	for _, okItem := range ok {
		okRule = append(okRule, okItem)
	}
	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}

	logs, sub, err := _Validator.contract.FilterLogs(opts, "ValidatorChanged", addrRule, okRule, countRule)
	if err != nil {
		return nil, err
	}
	return &ValidatorValidatorChangedIterator{contract: _Validator.contract, event: "ValidatorChanged", logs: logs, sub: sub}, nil
}

// WatchValidatorChanged is a free log subscription operation binding the contract event 0x68eee2a57e96a90e746ad2bfb99fd2baa69684672e6f1ea09adad5eb88f3914a.
//
// Solidity: event ValidatorChanged(address indexed addr, bool indexed ok, uint256 indexed count)
func (_Validator *ValidatorFilterer) WatchValidatorChanged(opts *bind.WatchOpts, sink chan<- *ValidatorValidatorChanged, addr []common.Address, ok []bool, count []*big.Int) (event.Subscription, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}
	var okRule []interface{}
	for _, okItem := range ok {
		okRule = append(okRule, okItem)
	}
	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}

	logs, sub, err := _Validator.contract.WatchLogs(opts, "ValidatorChanged", addrRule, okRule, countRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(ValidatorValidatorChanged)
				if err := _Validator.contract.UnpackLog(event, "ValidatorChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseValidatorChanged is a log parse operation binding the contract event 0x68eee2a57e96a90e746ad2bfb99fd2baa69684672e6f1ea09adad5eb88f3914a.
//
// Solidity: event ValidatorChanged(address indexed addr, bool indexed ok, uint256 indexed count)
func (_Validator *ValidatorFilterer) ParseValidatorChanged(log types.Log) (*ValidatorValidatorChanged, error) {
	event := new(ValidatorValidatorChanged)
	if err := _Validator.contract.UnpackLog(event, "ValidatorChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
